<?php
/**
 * @package    Themify Builder Pro
 * @link       https://themify.me/
 */
class Tbp_Dynamic_Item_CustomField extends Tbp_Dynamic_Item {

	public static function get_category():string {
		return 'advanced';
	}

	public static function get_type():array {
		return array( 'text', 'textarea', 'image', 'wp_editor', 'url', 'custom_css', 'address', 'audio', 'video','slider_range' );
	}

	public static function get_label():string {
		return __( 'Custom Field', 'tbp' );
	}

	public static function get_value(array $args = array()):?string {
		$value = '';
		if ( ! empty( $args['custom_field'] ) ) {
            $value = get_post_meta( $args['post_id']??get_the_ID(), $args['custom_field'], true );
			if($value!==''){
				if ( is_array( $value ) ) {
					$value = current_user_can( 'manage_options' )?__( 'The data in this custom field is probably serialized and thus cannot be displayed directly.', 'tbp' ):'';
				} 
				elseif ( is_string( $value ) && isset( $args['custom_field_shortcode'] ) && $args['custom_field_shortcode'] === 'yes') {
					$value = do_shortcode( $value );
				}
			}
		}

		return $value;
	}

	public static function get_options():array {
		return array(
			array(
				'label' => 'cfield',
				'id' => 'custom_field',
				'type' => 'autocomplete',
				'dataset' => 'custom_fields',
			),
			array(
				'label' => __( 'Enable Shortcodes', 'tbp' ),
				'id' => 'custom_field_shortcode',
				'type' => 'select',
				'choose' => true,
				'help' => __( 'Enable parsing shortcodes on the custom field value.', 'tbp' ),
			),
			array(
				'label' => 'pstid',
				'id' => 'post_id',
				'type' => 'number',
				'help' => 'tbp_pstidh'
			),
		);
	}
}
